// Auto generated file
package com.vizor.mobile.api.files;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.RuntimeException;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class AndroidFileSystemProtocol {
  private static List<FileSystemProtocol> implementations = Collections.synchronizedList(new ArrayList<FileSystemProtocol>());

  private static Supplier implementationSupplier;

  private static final ObjectMapper objectMapper = new ObjectMapper();

  public static void initialize(Supplier supplier) {
    implementationSupplier = supplier;
  }

  public static int link() {
    int idx = implementations.indexOf(null);
    if (idx < 0) {
      idx = implementations.size();
      implementations.add(implementationSupplier.get());
    }
    else {
      implementations.set(idx, implementationSupplier.get());
    }
    return idx;
  }

  public static void unlink(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    implementations.set(handle, null);
  }

  public static FileSystemProtocol getImplementation(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    return implementations.get(handle);
  }

  public static long freeSpace(int _handle) {
    long _result = implementations.get(_handle).freeSpace();
    return _result;
  }

  public static byte[] loadResource(int _handle, byte[] path) throws IOException {
    String l_path = objectMapper.convert_ByteArray_To_String(path);
    byte[] _result = implementations.get(_handle).loadResource(l_path);
    return _result;
  }

  public static byte[] unzip(int _handle, byte[] zipArchive, byte[] dst) throws IOException {
    String l_dst = objectMapper.convert_ByteArray_To_String(dst);
    String[] _result = implementations.get(_handle).unzip(zipArchive, l_dst);
    return objectMapper.convert_StringArray_To_ByteArray(_result);
  }

  public interface Supplier {
    FileSystemProtocol get();
  }

  private static class ObjectMapper {
    String convert_ByteArray_To_String(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readString(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    byte[] convert_StringArray_To_ByteArray(String[] value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeStringArray(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    String readString(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return dis.readUTF();
      }
    }

    void writeStringArray(String[] object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeInt(object.length);
        for(int i = 0; i < object.length; i++) {
          dos.writeUTF(object[i]);
        }
      }
    }
  }
}
