// Auto generated file
package com.vizor.mobile.api.files;

import com.vizor.mobile.utils.RenderingThreadRunner;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.Override;
import java.lang.Runnable;
import java.lang.RuntimeException;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class AndroidNativeFileChannel {
  private static List<NativeFileChannel> implementations = Collections.synchronizedList(new ArrayList<NativeFileChannel>());

  private static Supplier implementationSupplier;

  private static final ObjectMapper objectMapper = new ObjectMapper();

  public static void initialize(Supplier supplier) {
    implementationSupplier = supplier;
  }

  public static int link(int fileProtocolHandle) {
    int idx = implementations.indexOf(null);
    if (idx < 0) {
      idx = implementations.size();
      implementations.add(implementationSupplier.get(fileProtocolHandle));
    }
    else {
      implementations.set(idx, implementationSupplier.get(fileProtocolHandle));
    }
    return idx;
  }

  public static void unlink(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    implementations.set(handle, null);
  }

  public static NativeFileChannel getImplementation(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    return implementations.get(handle);
  }

  public static void open(int _handle) throws IOException {
    implementations.get(_handle).open();
  }

  public static void read(int _handle, int offset, int len, long completionListener, long ctxPtr) {
    NativeCompletionHandler l_completionListener = new NativeCompletionHandler(completionListener, ctxPtr);
    implementations.get(_handle).read(offset, len, l_completionListener);
  }

  public static void read(int _handle, long completionHandler, long ctxPtr) {
    NativeCompletionHandler l_completionHandler = new NativeCompletionHandler(completionHandler, ctxPtr);
    implementations.get(_handle).read(l_completionHandler);
  }

  public static void readEncrypted(int _handle, long completionHandler, long ctxPtr) {
    NativeCompletionHandler l_completionHandler = new NativeCompletionHandler(completionHandler, ctxPtr);
    implementations.get(_handle).readEncrypted(l_completionHandler);
  }

  public static void write(int _handle, byte[] src, int offset, int len, boolean append,
      long completionListener, long ctxPtr) {
    NativeCompletionHandler l_completionListener = new NativeCompletionHandler(completionListener, ctxPtr);
    implementations.get(_handle).write(src, offset, len, append, l_completionListener);
  }

  public static void write(int _handle, byte[] src, boolean append, long completionHandler,
      long ctxPtr) {
    NativeCompletionHandler l_completionHandler = new NativeCompletionHandler(completionHandler, ctxPtr);
    implementations.get(_handle).write(src, append, l_completionHandler);
  }

  public static void writeEncrypted(int _handle, byte[] src, int offset, int len,
      long completionHandler, long ctxPtr) {
    NativeCompletionHandler l_completionHandler = new NativeCompletionHandler(completionHandler, ctxPtr);
    implementations.get(_handle).writeEncrypted(src, offset, len, l_completionHandler);
  }

  public static boolean close(int _handle) {
    boolean _result = implementations.get(_handle).close();
    return _result;
  }

  public static native void CompletionHandler_completed(long pointer, long ctxPointer, int result,
      byte[] attachment);

  public static native void CompletionHandler_failed(long pointer, long ctxPointer, byte[] error);

  public interface Supplier {
    NativeFileChannel get(int fileProtocolHandle);
  }

  private static class NativeCompletionHandler implements CompletionHandler {
    private final long pointer;

    private final long ctxPointer;

    NativeCompletionHandler(long handlerPointer, long protocolPointer) {
      this.pointer = handlerPointer;
      this.ctxPointer = protocolPointer;
    }

    @Override
    public void completed(final int result, final byte[] attachment) {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        CompletionHandler_completed(pointer, ctxPointer, result, attachment);;
      }
      });
    }

    @Override
    public void failed(final String error) {
      final byte[] l_error = objectMapper.convert_String_To_ByteArray(error);
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        CompletionHandler_failed(pointer, ctxPointer, l_error);;
      }
      });
    }
  }

  private static class ObjectMapper {
    byte[] convert_String_To_ByteArray(String value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeString(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    void writeString(String object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeUTF(object);
      }
    }
  }
}
