// Auto generated file
package com.vizor.mobile.api.files;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.RuntimeException;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class AndroidNativeFileProtocol {
  private static List<NativeFileProtocol> implementations = Collections.synchronizedList(new ArrayList<NativeFileProtocol>());

  private static Supplier implementationSupplier;

  private static final ObjectMapper objectMapper = new ObjectMapper();

  public static void initialize(Supplier supplier) {
    implementationSupplier = supplier;
  }

  public static int link(byte[] path) {
    String l_path = objectMapper.convert_ByteArray_To_String(path);
    int idx = implementations.indexOf(null);
    if (idx < 0) {
      idx = implementations.size();
      implementations.add(implementationSupplier.get(l_path));
    }
    else {
      implementations.set(idx, implementationSupplier.get(l_path));
    }
    return idx;
  }

  public static void unlink(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    implementations.set(handle, null);
  }

  public static NativeFileProtocol getImplementation(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    return implementations.get(handle);
  }

  public static boolean exists(int _handle) {
    boolean _result = implementations.get(_handle).exists();
    return _result;
  }

  public static boolean isDirectory(int _handle) {
    boolean _result = implementations.get(_handle).isDirectory();
    return _result;
  }

  public static boolean create(int _handle) throws IOException {
    boolean _result = implementations.get(_handle).create();
    return _result;
  }

  public static boolean mkdir(int _handle) {
    boolean _result = implementations.get(_handle).mkdir();
    return _result;
  }

  public static boolean remove(int _handle) {
    boolean _result = implementations.get(_handle).remove();
    return _result;
  }

  public static byte[] parent(int _handle) {
    String _result = implementations.get(_handle).parent();
    return objectMapper.convert_String_To_ByteArray(_result);
  }

  public static byte[] children(int _handle) {
    String[] _result = implementations.get(_handle).children();
    return objectMapper.convert_StringArray_To_ByteArray(_result);
  }

  public static int readBytes(int _handle, byte[] buffer, int offset, int length) throws
      IOException {
    int _result = implementations.get(_handle).readBytes(buffer, offset, length);
    return _result;
  }

  public static byte[] read(int _handle) throws IOException {
    byte[] _result = implementations.get(_handle).read();
    return _result;
  }

  public static byte[] readEncrypted(int _handle) throws IOException {
    byte[] _result = implementations.get(_handle).readEncrypted();
    return _result;
  }

  public static void writeBytes(int _handle, byte[] bytes, int offset, int length, boolean append)
      throws IOException {
    implementations.get(_handle).writeBytes(bytes, offset, length, append);
  }

  public static void writeEncrypted(int _handle, byte[] bytes, int offset, int length) throws
      IOException {
    implementations.get(_handle).writeEncrypted(bytes, offset, length);
  }

  public static long size(int _handle) throws IOException {
    long _result = implementations.get(_handle).size();
    return _result;
  }

  public static byte[] getName(int _handle) {
    String _result = implementations.get(_handle).getName();
    return objectMapper.convert_String_To_ByteArray(_result);
  }

  public static byte[] getPath(int _handle) {
    String _result = implementations.get(_handle).getPath();
    return objectMapper.convert_String_To_ByteArray(_result);
  }

  public static byte[] getAbsolutePath(int _handle) {
    String _result = implementations.get(_handle).getAbsolutePath();
    return objectMapper.convert_String_To_ByteArray(_result);
  }

  public interface Supplier {
    NativeFileProtocol get(String path);
  }

  private static class ObjectMapper {
    String convert_ByteArray_To_String(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readString(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    byte[] convert_String_To_ByteArray(String value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeString(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    byte[] convert_StringArray_To_ByteArray(String[] value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeStringArray(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    String readString(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return dis.readUTF();
      }
    }

    void writeString(String object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeUTF(object);
      }
    }

    void writeStringArray(String[] object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeInt(object.length);
        for(int i = 0; i < object.length; i++) {
          dos.writeUTF(object[i]);
        }
      }
    }
  }
}
