// Auto generated file
package com.vizor.mobile.api.files;

import com.vizor.mobile.app.ApplicationReference;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.lang.Throwable;

public final class CppFileSystemProtocol implements FileSystemProtocol {
  private final int _handle;

  private final ObjectMapper objectMapper = new ObjectMapper();

  public CppFileSystemProtocol(ApplicationReference appRef) {
    this._handle = nativeInit(appRef);
  }

  public int getHandle() {
    return _handle;
  }

  @Override
  public void finalize() throws Throwable {
    super.finalize();
    unlink(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void unlink(int handle);

  private int nativeInit(ApplicationReference appRef) {
    return nativeInit_nativeImpl(appRef);
  }

  /**
   * <source>
   * <skip>
   */
  private native int nativeInit_nativeImpl(ApplicationReference appRef);

  @Override
  public final long freeSpace() {
    return freeSpace_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native long freeSpace_nativeImpl(int _handle);

  @Override
  public final byte[] loadResource(String path) throws IOException {
    byte[] _converted_path = objectMapper.convert_String_To_ByteArray(path);
    return loadResource_nativeImpl(this._handle, _converted_path);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] loadResource_nativeImpl(int _handle, byte[] path) throws IOException;

  @Override
  public final String[] unzip(byte[] zipArchive, String dst) throws IOException {
    byte[] _converted_dst = objectMapper.convert_String_To_ByteArray(dst);
    byte[] _ret = unzip_nativeImpl(this._handle, zipArchive, _converted_dst);
    return objectMapper.convert_ByteArray_To_StringArray(_ret);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] unzip_nativeImpl(int _handle, byte[] zipArchive, byte[] dst) throws
      IOException;

  private static class ObjectMapper {
    byte[] convert_String_To_ByteArray(String value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeString(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    String[] convert_ByteArray_To_StringArray(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readStringArray(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String[] readStringArray(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        int size = dis.readInt();
        String[] arr = new String[size];;
        for(int i = 0; i < size; i++) {
          arr[i] = dis.readUTF();
        }
        return arr;
      }
    }

    void writeString(String object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeUTF(object);
      }
    }
  }
}
