// Auto generated file
// This file contains implementations for native methods from CppFileSystemProtocol
#include <jni.h>
#include <Native-priv.h>
#include "com/vizor/mobile/api/files/CppFileSystemProtocol.h"
#include "com/vizor/mobile/app/ApplicationReference.h"
#include "java/io/IOException.h"
#include "java/io/IOException.h"
#include "java/JavaArray.h"

namespace com {
namespace vizor {
namespace mobile {
namespace api {
namespace files {
namespace $CppFileSystemProtocol {

static jclass aClass;
static JNIEnv* env = NULL;
static JNIEnv* gcEnv = NULL;
static JavaVM* jvm = NULL;
static jmethodID freeSpaceMethodID_IJ;
static jmethodID loadResourceMethodID_IaBaB;
static jmethodID unzipMethodID_IaBaBaB;
static jmethodID linkId;
static jmethodID unlinkId;

int CppFileSystemProtocol::nativeInit_nativeImpl(com::vizor::mobile::app::ApplicationReference* app)
{
  if (env == NULL) {
    env = (JNIEnv*)(void*) app->getEnv();
    jvm = (JavaVM*)(void*) app->getJvm();
    aClass = (jclass) env->NewGlobalRef(env->FindClass("com/vizor/mobile/api/files/AndroidFileSystemProtocol"));
    freeSpaceMethodID_IJ = env->GetStaticMethodID(aClass, "freeSpace", "(I)J");
    loadResourceMethodID_IaBaB = env->GetStaticMethodID(aClass, "loadResource", "(I[B)[B");
    unzipMethodID_IaBaBaB = env->GetStaticMethodID(aClass, "unzip", "(I[B[B)[B");
    linkId = env->GetStaticMethodID(aClass, "link", "()I");
    unlinkId = env->GetStaticMethodID(aClass, "unlink", "(I)V");
  }
  int handle = env->CallStaticIntMethod(aClass, linkId);
  return handle;
}

void CppFileSystemProtocol::unlink(int handle)
{
  int envStatus = jvm->GetEnv((void**)&gcEnv, JNI_VERSION_1_6);
  boolean attached;
  if (envStatus == JNI_EDETACHED) {
    attached = (jvm->AttachCurrentThread(&gcEnv, NULL) == JNI_OK);
  }
  if (attached) {
    gcEnv->CallStaticVoidMethod(aClass, unlinkId, handle);
    jvm->DetachCurrentThread();
  }
}

jvmtypes::jlong CppFileSystemProtocol::freeSpace_nativeImpl(int _handle)
{
  jvmtypes::jlong _result = env->CallStaticLongMethod(aClass, freeSpaceMethodID_IJ, _handle);
  return _result;
}

jvm::ajbyte* CppFileSystemProtocol::loadResource_nativeImpl(int _handle, jvm::ajbyte* path)
{
  jbyteArray l_path = env->NewByteArray(path->length);
  env->SetByteArrayRegion(l_path, 0, path->length, path->values);

  jbyteArray _jresult = static_cast<jbyteArray>(env->CallStaticObjectMethod(aClass, loadResourceMethodID_IaBaB, _handle, l_path));

  env->DeleteLocalRef(l_path);

  // Exception handling
  jthrowable _x;
  if (_x = env->ExceptionOccurred()) {
    env->ExceptionClear();
    jclass throwableClass = env->FindClass("java/lang/Throwable");
    jmethodID getMessageMethodID = env->GetMethodID(throwableClass, "getMessage","()Ljava/lang/String;");
    jstring _exceptionMessage = (jstring) env->CallObjectMethod(_x, getMessageMethodID);
    java::lang::String* _exceptionMessageString = native::fromJniString(_exceptionMessage);
    jTHROW(java::io::IOException::$newIOException(_exceptionMessageString));
  }

  int _rsize = env->GetArrayLength(_jresult);
  jbyte* _jbytes = env->GetByteArrayElements(_jresult, 0);
  // Resulting value
  jvm::ajbyte* _result = jvm::ajbyte::$new(_rsize);

  memcpy((void*) _result->values, _jbytes, _rsize);
  env->ReleaseByteArrayElements(_jresult, _jbytes, 0);

  return _result;
}

jvm::ajbyte* CppFileSystemProtocol::unzip_nativeImpl(int _handle, jvm::ajbyte* zipArchive,
    jvm::ajbyte* dst)
{
  jbyteArray l_zipArchive = env->NewByteArray(zipArchive->length);
  env->SetByteArrayRegion(l_zipArchive, 0, zipArchive->length, zipArchive->values);

  jbyteArray l_dst = env->NewByteArray(dst->length);
  env->SetByteArrayRegion(l_dst, 0, dst->length, dst->values);

  jbyteArray _jresult = static_cast<jbyteArray>(env->CallStaticObjectMethod(aClass, unzipMethodID_IaBaBaB, _handle, l_zipArchive, l_dst));

  env->DeleteLocalRef(l_zipArchive);
  env->DeleteLocalRef(l_dst);

  // Exception handling
  jthrowable _x;
  if (_x = env->ExceptionOccurred()) {
    env->ExceptionClear();
    jclass throwableClass = env->FindClass("java/lang/Throwable");
    jmethodID getMessageMethodID = env->GetMethodID(throwableClass, "getMessage","()Ljava/lang/String;");
    jstring _exceptionMessage = (jstring) env->CallObjectMethod(_x, getMessageMethodID);
    java::lang::String* _exceptionMessageString = native::fromJniString(_exceptionMessage);
    jTHROW(java::io::IOException::$newIOException(_exceptionMessageString));
  }

  int _rsize = env->GetArrayLength(_jresult);
  jbyte* _jbytes = env->GetByteArrayElements(_jresult, 0);
  // Resulting value
  jvm::ajbyte* _result = jvm::ajbyte::$new(_rsize);

  memcpy((void*) _result->values, _jbytes, _rsize);
  env->ReleaseByteArrayElements(_jresult, _jbytes, 0);

  return _result;
}
} // ::$CppFileSystemProtocol
} // ::files
} // ::api
} // ::mobile
} // ::vizor
} // ::com
