// Auto generated file
package com.vizor.mobile.api.files;

import com.vizor.mobile.app.ApplicationReference;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.Throwable;
import java.util.ArrayList;
import java.util.List;

public final class CppNativeFileChannel implements NativeFileChannel {
  private final int _handle;

  private final List<Object> _references = new ArrayList<Object>();

  private final ObjectMapper objectMapper = new ObjectMapper();

  public CppNativeFileChannel(ApplicationReference appRef, int fileProtocolHandle) {
    this._handle = nativeInit(appRef, fileProtocolHandle);
  }

  public int getHandle() {
    return _handle;
  }

  @Override
  public void finalize() throws Throwable {
    super.finalize();
    unlink(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void unlink(int handle);

  private int nativeInit(ApplicationReference appRef, int fileProtocolHandle) {
    return nativeInit_nativeImpl(appRef, fileProtocolHandle);
  }

  /**
   * <source>
   * <skip>
   */
  private native int nativeInit_nativeImpl(ApplicationReference appRef, int fileProtocolHandle);

  @Override
  public final void open() throws IOException {
    open_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void open_nativeImpl(int _handle) throws IOException;

  @Override
  public final void read(int offset, int len, CompletionHandler completionListener) {
    _references.add(completionListener); // add callback
    read_nativeImpl(this._handle, offset, len, completionListener);
  }

  /**
   * <source>
   * <skip>
   */
  private native void read_nativeImpl(int _handle, int offset, int len,
      CompletionHandler completionListener);

  @Override
  public final void read(CompletionHandler completionHandler) {
    _references.add(completionHandler); // add callback
    read_nativeImpl(this._handle, completionHandler);
  }

  /**
   * <source>
   * <skip>
   */
  private native void read_nativeImpl(int _handle, CompletionHandler completionHandler);

  @Override
  public final void readEncrypted(CompletionHandler completionHandler) {
    _references.add(completionHandler); // add callback
    readEncrypted_nativeImpl(this._handle, completionHandler);
  }

  /**
   * <source>
   * <skip>
   */
  private native void readEncrypted_nativeImpl(int _handle, CompletionHandler completionHandler);

  @Override
  public final void write(byte[] src, int offset, int len, boolean append,
      CompletionHandler completionListener) {
    _references.add(completionListener); // add callback
    write_nativeImpl(this._handle, src, offset, len, append, completionListener);
  }

  /**
   * <source>
   * <skip>
   */
  private native void write_nativeImpl(int _handle, byte[] src, int offset, int len, boolean append,
      CompletionHandler completionListener);

  @Override
  public final void write(byte[] src, boolean append, CompletionHandler completionHandler) {
    _references.add(completionHandler); // add callback
    write_nativeImpl(this._handle, src, append, completionHandler);
  }

  /**
   * <source>
   * <skip>
   */
  private native void write_nativeImpl(int _handle, byte[] src, boolean append,
      CompletionHandler completionHandler);

  @Override
  public final void writeEncrypted(byte[] src, int offset, int len,
      CompletionHandler completionHandler) {
    _references.add(completionHandler); // add callback
    writeEncrypted_nativeImpl(this._handle, src, offset, len, completionHandler);
  }

  /**
   * <source>
   * <skip>
   */
  private native void writeEncrypted_nativeImpl(int _handle, byte[] src, int offset, int len,
      CompletionHandler completionHandler);

  @Override
  public final boolean close() {
    return close_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native boolean close_nativeImpl(int _handle);

  void CompletionHandler_completed(CompletionHandler _handler, int result, byte[] attachment) {
    _references.remove(_handler);
    _handler.completed(result, attachment);
  }

  void CompletionHandler_failed(CompletionHandler _handler, byte[] error) {
    _references.remove(_handler);

    String l_error = objectMapper.convert_ByteArray_To_String(error);

    _handler.failed(l_error);
  }

  private static class ObjectMapper {
    String convert_ByteArray_To_String(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readString(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String readString(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return dis.readUTF();
      }
    }
  }
}
