// Auto generated file
// This file contains implementations for native methods from CppNativeFileChannel
#include <jni.h>
#include <Native-priv.h>
#include "com/vizor/mobile/api/files/CppNativeFileChannel.h"
#include "com/vizor/mobile/app/ApplicationReference.h"
#include "java/io/IOException.h"
#include "com/vizor/mobile/api/files/CompletionHandler.h"
#include "java/JavaArray.h"
#include "com/vizor/mobile/api/files/com_vizor_mobile_api_files_AndroidNativeFileChannel.h"

namespace com {
namespace vizor {
namespace mobile {
namespace api {
namespace files {
namespace $CppNativeFileChannel {

static jclass aClass;
static JNIEnv* env = NULL;
static JNIEnv* gcEnv = NULL;
static JavaVM* jvm = NULL;
static jmethodID openMethodID_IV;
static jmethodID readMethodID_IIIJJV;
static jmethodID readMethodID_IJJV;
static jmethodID readEncryptedMethodID_IJJV;
static jmethodID writeMethodID_IaBIIZJJV;
static jmethodID writeMethodID_IaBZJJV;
static jmethodID writeEncryptedMethodID_IaBIIJJV;
static jmethodID closeMethodID_IZ;
static jmethodID linkId;
static jmethodID unlinkId;

int CppNativeFileChannel::nativeInit_nativeImpl(com::vizor::mobile::app::ApplicationReference* app,
    jvmtypes::jint fileProtocolHandle)
{
  if (env == NULL) {
    env = (JNIEnv*)(void*) app->getEnv();
    jvm = (JavaVM*)(void*) app->getJvm();
    aClass = (jclass) env->NewGlobalRef(env->FindClass("com/vizor/mobile/api/files/AndroidNativeFileChannel"));
    openMethodID_IV = env->GetStaticMethodID(aClass, "open", "(I)V");
    readMethodID_IIIJJV = env->GetStaticMethodID(aClass, "read", "(IIIJJ)V");
    readMethodID_IJJV = env->GetStaticMethodID(aClass, "read", "(IJJ)V");
    readEncryptedMethodID_IJJV = env->GetStaticMethodID(aClass, "readEncrypted", "(IJJ)V");
    writeMethodID_IaBIIZJJV = env->GetStaticMethodID(aClass, "write", "(I[BIIZJJ)V");
    writeMethodID_IaBZJJV = env->GetStaticMethodID(aClass, "write", "(I[BZJJ)V");
    writeEncryptedMethodID_IaBIIJJV = env->GetStaticMethodID(aClass, "writeEncrypted", "(I[BIIJJ)V");
    closeMethodID_IZ = env->GetStaticMethodID(aClass, "close", "(I)Z");
    linkId = env->GetStaticMethodID(aClass, "link", "(I)I");
    unlinkId = env->GetStaticMethodID(aClass, "unlink", "(I)V");
  }
  int handle = env->CallStaticIntMethod(aClass, linkId, fileProtocolHandle);
  return handle;
}

void CppNativeFileChannel::unlink(int handle)
{
  int envStatus = jvm->GetEnv((void**)&gcEnv, JNI_VERSION_1_6);
  boolean attached;
  if (envStatus == JNI_EDETACHED) {
    attached = (jvm->AttachCurrentThread(&gcEnv, NULL) == JNI_OK);
  }
  if (attached) {
    gcEnv->CallStaticVoidMethod(aClass, unlinkId, handle);
    jvm->DetachCurrentThread();
  }
}

void CppNativeFileChannel::open_nativeImpl(int _handle)
{
  env->CallStaticVoidMethod(aClass, openMethodID_IV, _handle);

  // Exception handling
  jthrowable _x;
  if (_x = env->ExceptionOccurred()) {
    env->ExceptionClear();
    jclass throwableClass = env->FindClass("java/lang/Throwable");
    jmethodID getMessageMethodID = env->GetMethodID(throwableClass, "getMessage","()Ljava/lang/String;");
    jstring _exceptionMessage = (jstring) env->CallObjectMethod(_x, getMessageMethodID);
    java::lang::String* _exceptionMessageString = native::fromJniString(_exceptionMessage);
    jTHROW(java::io::IOException::$newIOException(_exceptionMessageString));
  }

}

void CppNativeFileChannel::read_nativeImpl(int _handle, jvmtypes::jint offset, jvmtypes::jint len,
    com::vizor::mobile::api::files::CompletionHandler* completionListener)
{
  env->CallStaticVoidMethod(aClass, readMethodID_IIIJJV, _handle, offset, len, (jlong)completionListener, (jlong) this);
}

void CppNativeFileChannel::read_nativeImpl(int _handle,
    com::vizor::mobile::api::files::CompletionHandler* completionHandler)
{
  env->CallStaticVoidMethod(aClass, readMethodID_IJJV, _handle, (jlong)completionHandler, (jlong) this);
}

void CppNativeFileChannel::readEncrypted_nativeImpl(int _handle,
    com::vizor::mobile::api::files::CompletionHandler* completionHandler)
{
  env->CallStaticVoidMethod(aClass, readEncryptedMethodID_IJJV, _handle, (jlong)completionHandler, (jlong) this);
}

void CppNativeFileChannel::write_nativeImpl(int _handle, jvm::ajbyte* src, jvmtypes::jint offset,
    jvmtypes::jint len, jvmtypes::jboolean append,
    com::vizor::mobile::api::files::CompletionHandler* completionListener)
{
  jbyteArray l_src = env->NewByteArray(src->length);
  env->SetByteArrayRegion(l_src, 0, src->length, src->values);

  env->CallStaticVoidMethod(aClass, writeMethodID_IaBIIZJJV, _handle, l_src, offset, len, append, (jlong)completionListener, (jlong) this);
  env->DeleteLocalRef(l_src);
}

void CppNativeFileChannel::write_nativeImpl(int _handle, jvm::ajbyte* src,
    jvmtypes::jboolean append, com::vizor::mobile::api::files::CompletionHandler* completionHandler)
{
  jbyteArray l_src = env->NewByteArray(src->length);
  env->SetByteArrayRegion(l_src, 0, src->length, src->values);

  env->CallStaticVoidMethod(aClass, writeMethodID_IaBZJJV, _handle, l_src, append, (jlong)completionHandler, (jlong) this);
  env->DeleteLocalRef(l_src);
}

void CppNativeFileChannel::writeEncrypted_nativeImpl(int _handle, jvm::ajbyte* src,
    jvmtypes::jint offset, jvmtypes::jint len,
    com::vizor::mobile::api::files::CompletionHandler* completionHandler)
{
  jbyteArray l_src = env->NewByteArray(src->length);
  env->SetByteArrayRegion(l_src, 0, src->length, src->values);

  env->CallStaticVoidMethod(aClass, writeEncryptedMethodID_IaBIIJJV, _handle, l_src, offset, len, (jlong)completionHandler, (jlong) this);
  env->DeleteLocalRef(l_src);
}

jvmtypes::jboolean CppNativeFileChannel::close_nativeImpl(int _handle)
{
  jvmtypes::jboolean _result = env->CallStaticBooleanMethod(aClass, closeMethodID_IZ, _handle);
  return _result;
}
} // ::$CppNativeFileChannel
} // ::files
} // ::api
} // ::mobile
} // ::vizor
} // ::com

JNIEXPORT void JNICALL Java_com_vizor_mobile_api_files_AndroidNativeFileChannel_CompletionHandler_1completed(
    JNIEnv* env, jclass _class, jlong ptr, jlong ctxPtr, jint result, jbyteArray attachment)
{
  int attachment_size = env->GetArrayLength(attachment);
  jbyte* attachment_bytes = env->GetByteArrayElements(attachment, 0);
  jvm::ajbyte* l_attachment = jvm::ajbyte::$new(attachment_size);
  memcpy((void*) l_attachment->values, attachment_bytes, attachment_size);
  env->ReleaseByteArrayElements(attachment, attachment_bytes, 0);

  reinterpret_cast<com::vizor::mobile::api::files::CppNativeFileChannel*>((void*) ctxPtr)->CompletionHandler_completed(reinterpret_cast<com::vizor::mobile::api::files::CompletionHandler*>((void*) ptr), result, l_attachment);
}

JNIEXPORT void JNICALL Java_com_vizor_mobile_api_files_AndroidNativeFileChannel_CompletionHandler_1failed(
    JNIEnv* env, jclass _class, jlong ptr, jlong ctxPtr, jbyteArray error)
{
  int error_size = env->GetArrayLength(error);
  jbyte* error_bytes = env->GetByteArrayElements(error, 0);
  jvm::ajbyte* l_error = jvm::ajbyte::$new(error_size);
  memcpy((void*) l_error->values, error_bytes, error_size);
  env->ReleaseByteArrayElements(error, error_bytes, 0);

  reinterpret_cast<com::vizor::mobile::api::files::CppNativeFileChannel*>((void*) ctxPtr)->CompletionHandler_failed(reinterpret_cast<com::vizor::mobile::api::files::CompletionHandler*>((void*) ptr), l_error);
}
