// Auto generated file
package com.vizor.mobile.api.files;

import com.vizor.mobile.app.ApplicationReference;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;
import java.lang.Throwable;

public final class CppNativeFileProtocol implements NativeFileProtocol {
  private final int _handle;

  private final ObjectMapper objectMapper = new ObjectMapper();

  public CppNativeFileProtocol(ApplicationReference appRef, String path) {
    this._handle = nativeInit(appRef, path);
  }

  public int getHandle() {
    return _handle;
  }

  @Override
  public void finalize() throws Throwable {
    super.finalize();
    unlink(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void unlink(int handle);

  private int nativeInit(ApplicationReference appRef, String path) {
    byte[] _converted_path = objectMapper.convert_String_To_ByteArray(path);
    return nativeInit_nativeImpl(appRef, _converted_path);
  }

  /**
   * <source>
   * <skip>
   */
  private native int nativeInit_nativeImpl(ApplicationReference appRef, byte[] path);

  @Override
  public final boolean exists() {
    return exists_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native boolean exists_nativeImpl(int _handle);

  @Override
  public final boolean isDirectory() {
    return isDirectory_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native boolean isDirectory_nativeImpl(int _handle);

  @Override
  public final boolean create() throws IOException {
    return create_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native boolean create_nativeImpl(int _handle) throws IOException;

  @Override
  public final boolean mkdir() {
    return mkdir_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native boolean mkdir_nativeImpl(int _handle);

  @Override
  public final boolean remove() {
    return remove_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native boolean remove_nativeImpl(int _handle);

  @Override
  public final String parent() {
    byte[] _ret = parent_nativeImpl(this._handle);
    return objectMapper.convert_ByteArray_To_String(_ret);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] parent_nativeImpl(int _handle);

  @Override
  public final String[] children() {
    byte[] _ret = children_nativeImpl(this._handle);
    return objectMapper.convert_ByteArray_To_StringArray(_ret);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] children_nativeImpl(int _handle);

  @Override
  public final int readBytes(byte[] buffer, int offset, int length) throws IOException {
    return readBytes_nativeImpl(this._handle, buffer, offset, length);
  }

  /**
   * <source>
   * <skip>
   */
  private native int readBytes_nativeImpl(int _handle, byte[] buffer, int offset, int length) throws
      IOException;

  @Override
  public final byte[] read() throws IOException {
    return read_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] read_nativeImpl(int _handle) throws IOException;

  @Override
  public final byte[] readEncrypted() throws IOException {
    return readEncrypted_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] readEncrypted_nativeImpl(int _handle) throws IOException;

  @Override
  public final void writeBytes(byte[] bytes, int offset, int length, boolean append) throws
      IOException {
    writeBytes_nativeImpl(this._handle, bytes, offset, length, append);
  }

  /**
   * <source>
   * <skip>
   */
  private native void writeBytes_nativeImpl(int _handle, byte[] bytes, int offset, int length,
      boolean append) throws IOException;

  @Override
  public final void writeEncrypted(byte[] bytes, int offset, int length) throws IOException {
    writeEncrypted_nativeImpl(this._handle, bytes, offset, length);
  }

  /**
   * <source>
   * <skip>
   */
  private native void writeEncrypted_nativeImpl(int _handle, byte[] bytes, int offset, int length)
      throws IOException;

  @Override
  public final long size() throws IOException {
    return size_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native long size_nativeImpl(int _handle) throws IOException;

  @Override
  public final String getName() {
    byte[] _ret = getName_nativeImpl(this._handle);
    return objectMapper.convert_ByteArray_To_String(_ret);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] getName_nativeImpl(int _handle);

  @Override
  public final String getPath() {
    byte[] _ret = getPath_nativeImpl(this._handle);
    return objectMapper.convert_ByteArray_To_String(_ret);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] getPath_nativeImpl(int _handle);

  @Override
  public final String getAbsolutePath() {
    byte[] _ret = getAbsolutePath_nativeImpl(this._handle);
    return objectMapper.convert_ByteArray_To_String(_ret);
  }

  /**
   * <source>
   * <skip>
   */
  private native byte[] getAbsolutePath_nativeImpl(int _handle);

  private static class ObjectMapper {
    byte[] convert_String_To_ByteArray(String value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeString(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    String convert_ByteArray_To_String(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readString(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String[] convert_ByteArray_To_StringArray(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readStringArray(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String readString(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return dis.readUTF();
      }
    }

    String[] readStringArray(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        int size = dis.readInt();
        String[] arr = new String[size];;
        for(int i = 0; i < size; i++) {
          arr[i] = dis.readUTF();
        }
        return arr;
      }
    }

    void writeString(String object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeUTF(object);
      }
    }
  }
}
