// Auto generated file
package com.vizor.mobile.helpshift;

import com.vizor.mobile.helpshift.config.ContactUsPolicy;
import com.vizor.mobile.utils.RenderingThreadRunner;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.Override;
import java.lang.Runnable;
import java.lang.RuntimeException;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class AndroidHelpShiftApiProtocol {
  private static List<HelpShiftApiProtocol> implementations = Collections.synchronizedList(new ArrayList<HelpShiftApiProtocol>());

  private static Supplier implementationSupplier;

  private static final ObjectMapper objectMapper = new ObjectMapper();

  public static void initialize(Supplier supplier) {
    implementationSupplier = supplier;
  }

  public static int link() {
    int idx = implementations.indexOf(null);
    if (idx < 0) {
      idx = implementations.size();
      implementations.add(implementationSupplier.get());
    }
    else {
      implementations.set(idx, implementationSupplier.get());
    }
    return idx;
  }

  public static void unlink(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    implementations.set(handle, null);
  }

  public static HelpShiftApiProtocol getImplementation(int handle) {
    if (handle < 0 || handle >= implementations.size()) {
      throw new RuntimeException("Invalid handle: " + handle);
    }
    return implementations.get(handle);
  }

  public static void setup(int _handle, byte[] apiKey, byte[] domainName, byte[] appId) {
    String l_apiKey = objectMapper.convert_ByteArray_To_String(apiKey);
    String l_domainName = objectMapper.convert_ByteArray_To_String(domainName);
    String l_appId = objectMapper.convert_ByteArray_To_String(appId);
    implementations.get(_handle).setup(l_apiKey, l_domainName, l_appId);
  }

  public static void addUserIntProperty(int _handle, byte[] name, int value) {
    String l_name = objectMapper.convert_ByteArray_To_String(name);
    implementations.get(_handle).addUserIntProperty(l_name, value);
  }

  public static void addUserDateProperty(int _handle, byte[] name, byte[] value) {
    String l_name = objectMapper.convert_ByteArray_To_String(name);
    String l_value = objectMapper.convert_ByteArray_To_String(value);
    implementations.get(_handle).addUserDateProperty(l_name, l_value);
  }

  public static void addUserStringProperty(int _handle, byte[] name, byte[] value) {
    String l_name = objectMapper.convert_ByteArray_To_String(name);
    String l_value = objectMapper.convert_ByteArray_To_String(value);
    implementations.get(_handle).addUserStringProperty(l_name, l_value);
  }

  public static void addUserBooleanProperty(int _handle, byte[] name, boolean value) {
    String l_name = objectMapper.convert_ByteArray_To_String(name);
    implementations.get(_handle).addUserBooleanProperty(l_name, value);
  }

  public static void clearProperties(int _handle) {
    implementations.get(_handle).clearProperties();
  }

  public static void setLanguage(int _handle, byte[] langCode) {
    String l_langCode = objectMapper.convert_ByteArray_To_String(langCode);
    implementations.get(_handle).setLanguage(l_langCode);
  }

  public static void setTags(int _handle, byte[] tags) {
    String[] l_tags = objectMapper.convert_ByteArray_To_StringArray(tags);
    implementations.get(_handle).setTags(l_tags);
  }

  public static void showSupportConversation(int _handle) {
    implementations.get(_handle).showSupportConversation();
  }

  public static void showFAQ(int _handle) {
    implementations.get(_handle).showFAQ();
  }

  public static void showFAQ(int _handle, byte[] sectionId) {
    String l_sectionId = objectMapper.convert_ByteArray_To_String(sectionId);
    implementations.get(_handle).showFAQ(l_sectionId);
  }

  public static void showSingleFAQ(int _handle, byte[] publishId) {
    String l_publishId = objectMapper.convert_ByteArray_To_String(publishId);
    implementations.get(_handle).showSingleFAQ(l_publishId);
  }

  public static void setUserIdentifier(int _handle, byte[] uid, byte[] name, byte[] email) {
    String l_uid = objectMapper.convert_ByteArray_To_String(uid);
    String l_name = objectMapper.convert_ByteArray_To_String(name);
    String l_email = objectMapper.convert_ByteArray_To_String(email);
    implementations.get(_handle).setUserIdentifier(l_uid, l_name, l_email);
  }

  public static void setEnableContactUs(int _handle, byte[] contactUs) {
    ContactUsPolicy l_contactUs = objectMapper.convert_ByteArray_To_ContactUsPolicy(contactUs);
    implementations.get(_handle).setEnableContactUs(l_contactUs);
  }

  public static void setShowSearchOnNewConversation(int _handle, boolean enabled) {
    implementations.get(_handle).setShowSearchOnNewConversation(enabled);
  }

  public static void requestUnreadMessagesCount(int _handle, long handler, long ctxPtr) {
    NativeHelpShiftNotificationHandler l_handler = new NativeHelpShiftNotificationHandler(handler, ctxPtr);
    implementations.get(_handle).requestUnreadMessagesCount(l_handler);
  }

  public static void checkIfConversationActive(int _handle, long handler, long ctxPtr) {
    NativeHelpShiftConversationHandler l_handler = new NativeHelpShiftConversationHandler(handler, ctxPtr);
    implementations.get(_handle).checkIfConversationActive(l_handler);
  }

  public static void addDelegate(int _handle, long delegate, long ctxPtr) {
    NativeHelpShiftDelegate l_delegate = new NativeHelpShiftDelegate(delegate, ctxPtr);
    implementations.get(_handle).addDelegate(l_delegate);
  }

  public static void removeDelegate(int _handle, long delegate, long ctxPtr) {
    NativeHelpShiftDelegate l_delegate = new NativeHelpShiftDelegate(delegate, ctxPtr);
    implementations.get(_handle).removeDelegate(l_delegate);
  }

  public static native void HelpShiftNotificationHandler_handleNotificationCountUpdate(long pointer,
      long ctxPointer, int count);

  public static native void HelpShiftNotificationHandler_handleNotificationError(long pointer,
      long ctxPointer);

  public static native void HelpShiftConversationHandler_handleConversationUpdate(long pointer,
      long ctxPointer, boolean active);

  public static native void HelpShiftConversationHandler_handleConversationError(long pointer,
      long ctxPointer);

  public static native void HelpShiftDelegate_sessionBegan(long pointer, long ctxPointer);

  public static native void HelpShiftDelegate_sessionEnded(long pointer, long ctxPointer);

  public static native void HelpShiftDelegate_newConversationStarted(long pointer, long ctxPointer,
      byte[] newConversationMessage);

  public static native void HelpShiftDelegate_conversationEnded(long pointer, long ctxPointer);

  public static native void HelpShiftDelegate_userRepliedToConversation(long pointer,
      long ctxPointer, byte[] newMessage);

  public static native void HelpShiftDelegate_userCompletedCustomerSatisfactionSurvey(long pointer,
      long ctxPointer, int rating, byte[] feedback);

  public static native void HelpShiftDelegate_didReceiveNotification(long pointer, long ctxPointer,
      int newMessagesCount);

  public interface Supplier {
    HelpShiftApiProtocol get();
  }

  private static class NativeHelpShiftNotificationHandler implements HelpShiftNotificationHandler {
    private final long pointer;

    private final long ctxPointer;

    NativeHelpShiftNotificationHandler(long handlerPointer, long protocolPointer) {
      this.pointer = handlerPointer;
      this.ctxPointer = protocolPointer;
    }

    @Override
    public void handleNotificationCountUpdate(final int count) {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftNotificationHandler_handleNotificationCountUpdate(pointer, ctxPointer, count);;
      }
      });
    }

    @Override
    public void handleNotificationError() {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftNotificationHandler_handleNotificationError(pointer, ctxPointer);;
      }
      });
    }
  }

  private static class NativeHelpShiftConversationHandler implements HelpShiftConversationHandler {
    private final long pointer;

    private final long ctxPointer;

    NativeHelpShiftConversationHandler(long handlerPointer, long protocolPointer) {
      this.pointer = handlerPointer;
      this.ctxPointer = protocolPointer;
    }

    @Override
    public void handleConversationUpdate(final boolean active) {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftConversationHandler_handleConversationUpdate(pointer, ctxPointer, active);;
      }
      });
    }

    @Override
    public void handleConversationError() {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftConversationHandler_handleConversationError(pointer, ctxPointer);;
      }
      });
    }
  }

  private static class NativeHelpShiftDelegate implements HelpShiftDelegate {
    private final long pointer;

    private final long ctxPointer;

    NativeHelpShiftDelegate(long handlerPointer, long protocolPointer) {
      this.pointer = handlerPointer;
      this.ctxPointer = protocolPointer;
    }

    @Override
    public void sessionBegan() {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_sessionBegan(pointer, ctxPointer);;
      }
      });
    }

    @Override
    public void sessionEnded() {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_sessionEnded(pointer, ctxPointer);;
      }
      });
    }

    @Override
    public void newConversationStarted(final String newConversationMessage) {
      final byte[] l_newConversationMessage = objectMapper.convert_String_To_ByteArray(newConversationMessage);
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_newConversationStarted(pointer, ctxPointer, l_newConversationMessage);;
      }
      });
    }

    @Override
    public void conversationEnded() {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_conversationEnded(pointer, ctxPointer);;
      }
      });
    }

    @Override
    public void userRepliedToConversation(final String newMessage) {
      final byte[] l_newMessage = objectMapper.convert_String_To_ByteArray(newMessage);
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_userRepliedToConversation(pointer, ctxPointer, l_newMessage);;
      }
      });
    }

    @Override
    public void userCompletedCustomerSatisfactionSurvey(final int rating, final String feedback) {
      final byte[] l_feedback = objectMapper.convert_String_To_ByteArray(feedback);
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_userCompletedCustomerSatisfactionSurvey(pointer, ctxPointer, rating, l_feedback);;
      }
      });
    }

    @Override
    public void didReceiveNotification(final int newMessagesCount) {
      new RenderingThreadRunner().run(new Runnable() {
      @Override public void run() {
        HelpShiftDelegate_didReceiveNotification(pointer, ctxPointer, newMessagesCount);;
      }
      });
    }
  }

  private static class ObjectMapper {
    ContactUsPolicy convert_ByteArray_To_ContactUsPolicy(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readContactUsPolicy(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String convert_ByteArray_To_String(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readString(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String[] convert_ByteArray_To_StringArray(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readStringArray(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    byte[] convert_String_To_ByteArray(String value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeString(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    ContactUsPolicy readContactUsPolicy(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return ContactUsPolicy.values()[dis.readInt()];
      }
    }

    String readString(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return dis.readUTF();
      }
    }

    String[] readStringArray(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        int size = dis.readInt();
        String[] arr = new String[size];;
        for(int i = 0; i < size; i++) {
          arr[i] = dis.readUTF();
        }
        return arr;
      }
    }

    void writeString(String object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeUTF(object);
      }
    }
  }
}
