// Auto generated file
package com.vizor.mobile.helpshift;

import com.vizor.mobile.app.ApplicationReference;
import com.vizor.mobile.helpshift.config.ContactUsPolicy;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.Throwable;
import java.util.ArrayList;
import java.util.List;

public final class CppHelpShiftApiProtocol implements HelpShiftApiProtocol {
  private final int _handle;

  private final List<Object> _references = new ArrayList<Object>();

  private final ObjectMapper objectMapper = new ObjectMapper();

  public CppHelpShiftApiProtocol(ApplicationReference appRef) {
    this._handle = nativeInit(appRef);
  }

  public int getHandle() {
    return _handle;
  }

  @Override
  public void finalize() throws Throwable {
    super.finalize();
    unlink(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void unlink(int handle);

  private int nativeInit(ApplicationReference appRef) {
    return nativeInit_nativeImpl(appRef);
  }

  /**
   * <source>
   * <skip>
   */
  private native int nativeInit_nativeImpl(ApplicationReference appRef);

  @Override
  public final void setup(String apiKey, String domainName, String appId) {
    byte[] _converted_apiKey = objectMapper.convert_String_To_ByteArray(apiKey);
    byte[] _converted_domainName = objectMapper.convert_String_To_ByteArray(domainName);
    byte[] _converted_appId = objectMapper.convert_String_To_ByteArray(appId);
    setup_nativeImpl(this._handle, _converted_apiKey, _converted_domainName, _converted_appId);
  }

  /**
   * <source>
   * <skip>
   */
  private native void setup_nativeImpl(int _handle, byte[] apiKey, byte[] domainName, byte[] appId);

  @Override
  public final void addUserIntProperty(String name, int value) {
    byte[] _converted_name = objectMapper.convert_String_To_ByteArray(name);
    addUserIntProperty_nativeImpl(this._handle, _converted_name, value);
  }

  /**
   * <source>
   * <skip>
   */
  private native void addUserIntProperty_nativeImpl(int _handle, byte[] name, int value);

  @Override
  public final void addUserDateProperty(String name, String value) {
    byte[] _converted_name = objectMapper.convert_String_To_ByteArray(name);
    byte[] _converted_value = objectMapper.convert_String_To_ByteArray(value);
    addUserDateProperty_nativeImpl(this._handle, _converted_name, _converted_value);
  }

  /**
   * <source>
   * <skip>
   */
  private native void addUserDateProperty_nativeImpl(int _handle, byte[] name, byte[] value);

  @Override
  public final void addUserStringProperty(String name, String value) {
    byte[] _converted_name = objectMapper.convert_String_To_ByteArray(name);
    byte[] _converted_value = objectMapper.convert_String_To_ByteArray(value);
    addUserStringProperty_nativeImpl(this._handle, _converted_name, _converted_value);
  }

  /**
   * <source>
   * <skip>
   */
  private native void addUserStringProperty_nativeImpl(int _handle, byte[] name, byte[] value);

  @Override
  public final void addUserBooleanProperty(String name, boolean value) {
    byte[] _converted_name = objectMapper.convert_String_To_ByteArray(name);
    addUserBooleanProperty_nativeImpl(this._handle, _converted_name, value);
  }

  /**
   * <source>
   * <skip>
   */
  private native void addUserBooleanProperty_nativeImpl(int _handle, byte[] name, boolean value);

  @Override
  public final void clearProperties() {
    clearProperties_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void clearProperties_nativeImpl(int _handle);

  @Override
  public final void setLanguage(String langCode) {
    byte[] _converted_langCode = objectMapper.convert_String_To_ByteArray(langCode);
    setLanguage_nativeImpl(this._handle, _converted_langCode);
  }

  /**
   * <source>
   * <skip>
   */
  private native void setLanguage_nativeImpl(int _handle, byte[] langCode);

  @Override
  public final void setTags(String[] tags) {
    byte[] _converted_tags = objectMapper.convert_StringArray_To_ByteArray(tags);
    setTags_nativeImpl(this._handle, _converted_tags);
  }

  /**
   * <source>
   * <skip>
   */
  private native void setTags_nativeImpl(int _handle, byte[] tags);

  @Override
  public final void showSupportConversation() {
    showSupportConversation_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void showSupportConversation_nativeImpl(int _handle);

  @Override
  public final void showFAQ() {
    showFAQ_nativeImpl(this._handle);
  }

  /**
   * <source>
   * <skip>
   */
  private native void showFAQ_nativeImpl(int _handle);

  @Override
  public final void showFAQ(String sectionId) {
    byte[] _converted_sectionId = objectMapper.convert_String_To_ByteArray(sectionId);
    showFAQ_nativeImpl(this._handle, _converted_sectionId);
  }

  /**
   * <source>
   * <skip>
   */
  private native void showFAQ_nativeImpl(int _handle, byte[] sectionId);

  @Override
  public final void showSingleFAQ(String publishId) {
    byte[] _converted_publishId = objectMapper.convert_String_To_ByteArray(publishId);
    showSingleFAQ_nativeImpl(this._handle, _converted_publishId);
  }

  /**
   * <source>
   * <skip>
   */
  private native void showSingleFAQ_nativeImpl(int _handle, byte[] publishId);

  @Override
  public final void setUserIdentifier(String uid, String name, String email) {
    byte[] _converted_uid = objectMapper.convert_String_To_ByteArray(uid);
    byte[] _converted_name = objectMapper.convert_String_To_ByteArray(name);
    byte[] _converted_email = objectMapper.convert_String_To_ByteArray(email);
    setUserIdentifier_nativeImpl(this._handle, _converted_uid, _converted_name, _converted_email);
  }

  /**
   * <source>
   * <skip>
   */
  private native void setUserIdentifier_nativeImpl(int _handle, byte[] uid, byte[] name,
      byte[] email);

  @Override
  public final void setEnableContactUs(ContactUsPolicy contactUs) {
    byte[] _converted_contactUs = objectMapper.convert_ContactUsPolicy_To_ByteArray(contactUs);
    setEnableContactUs_nativeImpl(this._handle, _converted_contactUs);
  }

  /**
   * <source>
   * <skip>
   */
  private native void setEnableContactUs_nativeImpl(int _handle, byte[] contactUs);

  @Override
  public final void setShowSearchOnNewConversation(boolean enabled) {
    setShowSearchOnNewConversation_nativeImpl(this._handle, enabled);
  }

  /**
   * <source>
   * <skip>
   */
  private native void setShowSearchOnNewConversation_nativeImpl(int _handle, boolean enabled);

  @Override
  public final void requestUnreadMessagesCount(HelpShiftNotificationHandler handler) {
    _references.add(handler); // add callback
    requestUnreadMessagesCount_nativeImpl(this._handle, handler);
  }

  /**
   * <source>
   * <skip>
   */
  private native void requestUnreadMessagesCount_nativeImpl(int _handle,
      HelpShiftNotificationHandler handler);

  @Override
  public final void checkIfConversationActive(HelpShiftConversationHandler handler) {
    _references.add(handler); // add callback
    checkIfConversationActive_nativeImpl(this._handle, handler);
  }

  /**
   * <source>
   * <skip>
   */
  private native void checkIfConversationActive_nativeImpl(int _handle,
      HelpShiftConversationHandler handler);

  @Override
  public final void addDelegate(HelpShiftDelegate delegate) {
    _references.add(delegate); // add listener
    addDelegate_nativeImpl(this._handle, delegate);
  }

  /**
   * <source>
   * <skip>
   */
  private native void addDelegate_nativeImpl(int _handle, HelpShiftDelegate delegate);

  @Override
  public final void removeDelegate(HelpShiftDelegate delegate) {
    _references.remove(delegate); // remove listener
    removeDelegate_nativeImpl(this._handle, delegate);
  }

  /**
   * <source>
   * <skip>
   */
  private native void removeDelegate_nativeImpl(int _handle, HelpShiftDelegate delegate);

  void HelpShiftNotificationHandler_handleNotificationCountUpdate(
      HelpShiftNotificationHandler _handler, int count) {
    _references.remove(_handler);
    _handler.handleNotificationCountUpdate(count);
  }

  void HelpShiftNotificationHandler_handleNotificationError(HelpShiftNotificationHandler _handler) {
    _references.remove(_handler);
    _handler.handleNotificationError();
  }

  void HelpShiftConversationHandler_handleConversationUpdate(HelpShiftConversationHandler _handler,
      boolean active) {
    _references.remove(_handler);
    _handler.handleConversationUpdate(active);
  }

  void HelpShiftConversationHandler_handleConversationError(HelpShiftConversationHandler _handler) {
    _references.remove(_handler);
    _handler.handleConversationError();
  }

  void HelpShiftDelegate_sessionBegan(HelpShiftDelegate _handler) {
    _handler.sessionBegan();
  }

  void HelpShiftDelegate_sessionEnded(HelpShiftDelegate _handler) {
    _handler.sessionEnded();
  }

  void HelpShiftDelegate_newConversationStarted(HelpShiftDelegate _handler,
      byte[] newConversationMessage) {

    String l_newConversationMessage = objectMapper.convert_ByteArray_To_String(newConversationMessage);

    _handler.newConversationStarted(l_newConversationMessage);
  }

  void HelpShiftDelegate_conversationEnded(HelpShiftDelegate _handler) {
    _handler.conversationEnded();
  }

  void HelpShiftDelegate_userRepliedToConversation(HelpShiftDelegate _handler, byte[] newMessage) {

    String l_newMessage = objectMapper.convert_ByteArray_To_String(newMessage);

    _handler.userRepliedToConversation(l_newMessage);
  }

  void HelpShiftDelegate_userCompletedCustomerSatisfactionSurvey(HelpShiftDelegate _handler,
      int rating, byte[] feedback) {

    String l_feedback = objectMapper.convert_ByteArray_To_String(feedback);

    _handler.userCompletedCustomerSatisfactionSurvey(rating, l_feedback);
  }

  void HelpShiftDelegate_didReceiveNotification(HelpShiftDelegate _handler, int newMessagesCount) {
    _handler.didReceiveNotification(newMessagesCount);
  }

  private static class ObjectMapper {
    byte[] convert_ContactUsPolicy_To_ByteArray(ContactUsPolicy value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeContactUsPolicy(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    byte[] convert_String_To_ByteArray(String value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeString(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    byte[] convert_StringArray_To_ByteArray(String[] value) {
      try {
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(buffer);
        writeStringArray(value, dos);
        dos.close();
        return buffer.toByteArray();
      } catch (IOException x) {
        return null;
      }
    }

    String convert_ByteArray_To_String(byte[] value) {
      try {
        DataInputStream buffer = new DataInputStream(new ByteArrayInputStream(value));
        return readString(buffer);
      } catch (IOException x) {
        return null;
      }
    }

    String readString(DataInputStream dis) throws IOException {
      boolean isNull = dis.readBoolean();
      if (isNull) {
        return null;
      } else {
        return dis.readUTF();
      }
    }

    void writeContactUsPolicy(ContactUsPolicy object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeInt(object.ordinal());
      }
    }

    void writeString(String object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeUTF(object);
      }
    }

    void writeStringArray(String[] object, DataOutputStream dos) throws IOException {
      if (object == null) {
        // write nullity marker
        dos.writeBoolean(true);
      } else {
        // write nullity marker
        dos.writeBoolean(false);
        dos.writeInt(object.length);
        for(int i = 0; i < object.length; i++) {
          dos.writeUTF(object[i]);
        }
      }
    }
  }
}
